<template>
    <div>
        <div class="box" v-if="section.section">
            <div class="box-header">
                <h1>{{section.section.name}}</h1>
            </div>
        </div>
        <div id="map">

        </div>
        <div class="box" v-if="sectionEfforts"> <!-- fix v-if -->
            <ul>
                <li
                    v-for="sectionEffort in sectionEfforts"
                    v-bind:key='sectionEffort.section_effort.id'
                >
                    <a :href="'/activity/' + sectionEffort.section_effort.activity_id">
                        {{formatTime(sectionEffort.section_effort.time)}}
                    </a>
                </li>
            </ul>
        </div>
    </div>
</template>

<script>
    import L from 'leaflet'

    let section = {}
    let sectionEfforts = []

    export default {
        data() {
            return {
                section,
                sectionEfforts
            }
        },
        computed: {
            api_key: function() {
                return this.$store.state.applicationSettings.application_settings
                    .find((setting) => setting.application_setting.code === 'mapbox_api_key')
                    .application_setting.text_value
            }
        },
        created: function () {
            this.$store.dispatch('show_section', {params: {id: this.$route.params.id}}).then(section => {
                this.section = section.data

                let map = L.map('map').setView([51.505, -0.09], 13)
                L.tileLayer(`https://api.tiles.mapbox.com/v4/{id}/{z}/{x}/{y}.png?access_token=${this.api_key}`, {
                    attribution: 'Map data &copy; <a href="https://www.openstreetmap.org/">OpenStreetMap</a> contributors, <a href="https://creativecommons.org/licenses/by-sa/2.0/">CC-BY-SA</a>, Imagery © <a href="https://www.mapbox.com/">Mapbox</a>',
                    maxZoom: 18,
                    id: 'mapbox.streets'
                }).addTo(map)

                let sectionLayer = L.geoJSON().addTo(map)
                sectionLayer.addData(this.section.section.path)

                map.fitBounds(sectionLayer.getBounds())
            }, response => {
                this.$notify({
                    group: 'error',
                    title: 'Error',
                    duration: -1,
                    text: response.response.data.status + " " + response.response.data.error
                })
            }).then( () => {
                    if (localStorage.getItem('uid')) {
                        this.$store.dispatch('show_current_user_section_efforts', {
                            params: {id: this.section.section.id}}).then(sectionEfforts => {
                                this.sectionEfforts = sectionEfforts.data
                        }, response => {
                            this.$notify({
                                group: 'error',
                                title: 'Error',
                                duration: -1,
                                text: response.response.data.status + " " + response.response.data.error
                            })
                        })
                    }
            })
        },
        methods: {
            formatTime: function (seconds) {
                // Hours, minutes and seconds
                let hrs = ~~(seconds / 3600);
                let mins = ~~((seconds % 3600) / 60);
                let secs = seconds % 60;

                // Output like "1:01" or "4:03:59" or "123:03:59"
                let ret = "";

                if (hrs > 0) {
                    ret += "" + hrs + ":" + (mins < 10 ? "0" : "");
                }

                ret += "" + mins + ":" + (secs < 10 ? "0" : "");
                ret += "" + secs;
                return ret;
            }
        }
    }
</script>

<style>
    #map {
        height: 500px
    }
</style>
